<?php

namespace Workers;

use MessageParsers;

class MessagesMoverWorker extends AbstractWorker
{
    static $typesMap = [
        'example' => 'ExampleParser',
    ];

    public function run($message)
    {
        $config = $this->getConfig();

        $db = $this->getDatabaseConnection();
        $stmt = $db->query("
            SELECT m.`payload`, t.`type_name`, m.`id` FROM `{$this->dbName}`.`queue_messages` AS m
            INNER JOIN `{$this->dbName}`.`queue_messages_types` AS t ON t.`id` = m.`type_id`
            WHERE m.`status` = 0
            ORDER BY m.`id`
        ");

        $isResult = false;

        while ($row = $stmt->fetch()) {
            $isResult = true;

            $className = 'MessageParsers\\' . self::$typesMap[$row['type_name']];

            if (class_exists($className)) {
                $parser = new $className();
                $payload = $parser->parse($row['payload']);
                $queueName = $payload['queue_name'];
                $message = $payload['message'];
            } else {    //  error
                var_dump($className);
                $db->exec("
                    UPDATE `{$this->dbName}`.`queue_messages`
                    SET `status` = 2
                    WHERE `id` = {$row['id']}
                ");

                return;
            }

            if ($this->publishQueueMessage($queueName, $message)) {
                $db->exec("
                    UPDATE `{$this->dbName}`.`queue_messages`
                    SET `status` = 1
                    WHERE `id` = {$row['id']}
                ");
            }
        }

        if (!$isResult) {
            sleep($config['self_config']['idle_interval']);
            return;
        }
    }
}
